unit PDF417DecodeDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ToolWin, ComCtrls, PDF417DecodeDll, jpeg,
  SynGdiPlus;

type
  TPDF417Sample = class(TForm)
    ToolBar: TToolBar;
    btnFile: TSpeedButton;
    btnRecognize: TSpeedButton;
    btnRecogFile: TSpeedButton;
    btnExit: TSpeedButton;
    paImage: TPanel;
    PaImgHead: TPanel;
    PaText: TPanel;
    PaInfoHead: TPanel;
    memInfo: TMemo;
    ImgView: TImage;
    dlgOpen: TOpenDialog;
    procedure btnFileClick(Sender: TObject);
    procedure btnRecognizeClick(Sender: TObject);
    procedure btnRecogFileClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FUNCTION Byte_To_Hex(X : byte) : String;
  public
    { Public declarations }
  end;

var
  PDF417Sample: TPDF417Sample;

  Digits : array [0..15] of char = '0123456789ABCDEF';
implementation

{$R *.dfm}

procedure TPDF417Sample.btnFileClick(Sender: TObject);
var
  MF : TSynPicture;
begin
  if dlgOpen.Execute then
  begin
    memInfo.Clear;
    MF := TSynPicture.Create;
    MF.LoadFromFile(dlgOpen.FileName);
    ImgView.Picture.Assign(MF.ToBitmap);
    MF.Free;
    btnRecognize.Enabled := True;
  end;
end;

procedure TPDF417Sample.btnRecognizeClick(Sender: TObject);
var
  pReturn : LPRESULT;
  nCount : Integer;
  pData : LPBYTE;
  aData : array[1..16] of BYTE;
  i : Integer;
  j : Integer;
  strHex : string;
  strAscll : string;
  strAll : string;
  strSpace : string;
  hBmp : HBITMAP;
begin
  if (memInfo.Text <> '') then
  begin
    memInfo.Clear;
  end;
  hBmp := Imgview.Picture.Bitmap.Handle;
 // pReturn := PDF417DecodeBitmap(hBmp);
  if (pReturn <> nil) then
  begin
    StrHex := '';
    StrAscll := '';
    StrAll := '';
    StrSpace := '';
    pData := pReturn.pData;
    j := 1;
    for i := 1 to pReturn.nSize  do
    begin
      aData[j] := pData^;
      StrHex := StrHex + Byte_To_Hex(aData[j]) + ' ';
      if (aData[j] >= 32) and (aData[j] <127) then
      begin
        StrAscll := StrAscll + chr(aData[j]);
      end
      else
      begin
        StrAscll := StrAscll + '.';
      end;
      Inc(pData);
      Inc(j);
      if (i mod 16 = 0) then
      begin
         StrAll := StrHex + '     ' + StrAscll;
         memInfo.Lines.Add(StrAll);
         j := 1;
         StrHex := '';
         StrAscll := '';
         StrAll := '';
      end;
     end;
     if j <> 1 then
     begin
       for i := 1 to (17-j) do
       begin
         StrSpace := StrSpace + '   ';
       end;
       StrAll := StrHex + StrSpace + '     ' + StrAscll;
       memInfo.Lines.Add(StrAll);
       StrHex := '';
       StrAscll := '';
       StrAll := '';
       StrSpace := '';
     end;
     PDF417Free(pReturn);
  end
  else
  begin
    memInfo.Clear;
    memInfo.Lines.Add('No barcode detected!');
  end;
end;

procedure TPDF417Sample.btnRecogFileClick(Sender: TObject);
var
  MF : TSynPicture;
  strFiles : string;
  pReturn : LPRESULT;
  nCount : Integer;
  pData : LPBYTE;
  aData : array[1..16] of BYTE;
  i : Integer;
  j : Integer;
  strHex : string;
  strAscll : string;
  strAll : string;
  strSpace : string;
  pFilePath : PChar;
begin
  if dlgOpen.Execute then
  begin
    if memInfo.Text <> '' then
    begin
      memInfo.Clear;
    end;
    MF := TSynPicture.Create;
    strFiles := dlgOpen.FileName;
    MF.LoadFromFile(strFiles);
    ImgView.Picture.Assign(MF.ToBitmap);
    MF.Free;

    pReturn := nil;
    pFilePath := @strFiles[1];
    pReturn := PDF417DecodeImageFile(pFilePath);
    if (pReturn <> nil) then
    begin
      StrHex := '';
      StrAscll := '';
      StrAll := '';
      StrSpace := '';
      pData := pReturn.pData;
      memInfo.Lines.Add('barcode detected,');
      strAll := strAll + 'Position:   ';
      for i := 1 to 4 do
      begin
        strAll := strAll + '(' + IntToStr(pReturn.ptsBarcode[i].X) + ',' + IntToStr(pReturn.ptsBarcode[i].Y) +')   ';
      end;
      memInfo.Lines.Add(strAll);
      memInfo.Lines.Add('Result:   ');
      strAll := '';
      j := 1;
      for i := 1 to pReturn.nSize  do
      begin
        aData[j] := pData^;
        StrHex := StrHex + Byte_To_Hex(aData[j]) + ' ';
        if (aData[j] >= 32) and (aData[j] <127) then
        begin
          StrAscll := StrAscll + chr(aData[j]);
        end
        else
        begin
          StrAscll := StrAscll + '.';
        end;
        Inc(pData);
        Inc(j);
        if (i mod 16 = 0) then
        begin
           StrAll := StrHex + '     ' + StrAscll;
           memInfo.Lines.Add(StrAll);
           j := 1;
           StrHex := '';
           StrAscll := '';
           StrAll := '';
        end;
       end;
       if j <> 1 then
       begin
         for i := 1 to (17-j) do
         begin
           StrSpace := StrSpace + '   ';
         end;
         StrAll := StrHex + StrSpace + '     ' + StrAscll;
         memInfo.Lines.Add(StrAll);
         StrHex := '';
         StrAscll := '';
         StrAll := '';
         StrSpace := '';
       end;
       PDF417Free(pReturn);
    end
    else
    begin
       memInfo.Clear;
       memInfo.Lines.Add('No barcode detected!');
    end;
    btnRecognize.Enabled := False;
  end;
end;

procedure TPDF417Sample.btnExitClick(Sender: TObject);
begin
  if MessageBox(0,PChar('Are you sure to exit?'),PChar('DecodeDemo'),
                MB_OKCANCEL)  = IDOK then
  begin
    close;
  end;
end;

FUNCTION TPDF417Sample.Byte_To_Hex(X : byte) : String;
BEGIN
  Byte_To_Hex := Concat(Digits[X shr 4],Digits[X and 15]);
END;

procedure TPDF417Sample.FormCreate(Sender: TObject);
var
strWarning : string;
begin
     Gdip := TGDIPlusFull.Create('gdiplus.dll');
     strWarning := '* Trial version will replace first char of the result with ' + '''' + '*' + '''' +' randomly';
     memInfo.Lines.Add(strWarning);
     strWarning := '* Please select or open file to decode';
     memInfo.Lines.Add(strWarning);
end;

end.
